/***
 * Excerpted from "Modern Systems Programming with Scala Native",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/rwscala for more book information.
***/
import scala.scalanative.unsafe._
import scala.scalanative.libc._

object Main {
  def main(args:Array[String]):Unit = {
    val str:CString = c"hello, world"
    val str_len = string.strlen(str)
    stdio.printf(c"the string '%s' at address %p is %d bytes long\n",
      str, str, str_len)
    stdio.printf(c"the CString value 'str' itself is %d bytes long\n",
      sizeof[CString])

    for (offset <- 0L to str_len) {
      val chr:CChar = str(offset)
      stdio.printf(c"""the character '%c' is %d bytes long and has binary
        value %d\n""", chr, sizeof[CChar], chr)
    }
  }
}
